<%@ page session="false"%>

<%@ page import="de.mutschler.rpdl.*" %>
<%@ page import="de.mutschler.rpdl.entity.*" %>
<%@ page import="de.mutschler.rpdl.fileimport.*" %>
<%@ page import="de.mutschler.util.Log" %>
<%@ page import="java.util.*" %>

<%-- creation of the character --%>
<%! RpdlBase main;
 	RpdlObject base;
	RpdlObject robj;	// used as the iterator over the subitems in the lists
	long execTime, calcTime;	// time for execution
%>
<% 
	main = new RpdlBase();
	Log.setLogLevel(Log.DEBUG);
	Log.setLogFile("rpdl.log");
	main.getConfig().setLocale(Locale.GERMAN);

	// The file-parameter of the request specifies the file to read
	String file = request.getParameter("file");
	if (file == null) throw new IllegalArgumentException("file-parameter not specified. Requires an absolute path!");
	FileImporter fi = new FileImporter(main, new File(file));	//"S:\\Save\\DA\\gurps\\McRathgar.rpdl"));
	long starttime = System.currentTimeMillis();
	main.suspend(true);
	fi.scanfile();
	long midtime = System.currentTimeMillis();
	main.suspend(false);
	long endtime = System.currentTimeMillis();
	execTime = endtime - starttime;
	calcTime = endtime - midtime;
	if (main.hasError()) {
%>
<%@include file="RpdlError.jsp" %>
<%
	} else {
	base = main.getBaseObject();
%>
<html>
<head><title>GURPS Charakterbogen von "<%= base.getAttribute("Name").getStringValue() %>"</title></head>
<body bgcolor="Silver">
<H1>GURPS Charakterbogen von <%= base.getAttribute("Name").getStringValue() %></H1>
<p>Execution time: <%=execTime%>ms  (calculation time: <%=calcTime%>ms)</p>
<TABLE border=2><TR>
<TD valign=top align=left>
  <TABLE cellpadding=3>
  <TR>
<!-------- Basic Attributes -------------------------------------->
    <TD><big><b>ST:<BR>GE:<BR>IQ:<BR>KO:</B></BIG></TD>
    <TD align=left><big>
	  <%= base.getAttribute("ST").getStringValue() %><BR>
	  <%= base.getAttribute("DX").getStringValue() %><BR>
	  <%= base.getAttribute("IQ").getStringValue() %><BR>
	  <%= base.getAttribute("CO").getStringValue() %>
	  </BIG></TD>
    <TD><b>Erschpfung:</B><BR>
	<%= base.getAttribute("Fatigue").getStringValue() %><BR>

<!-------- Damage ---------------------------------------------------------->
	<b>Grundschaden:</B><BR>
	<b>Schw:</B> <%= base.getAttribute("SwingDamage").getStringValue() %><BR>
	<b>Sto:</B> <%= base.getAttribute("ThrustDamage").getStringValue() %></TD>
  </TR>
  <TR valign=top>
<!-------- Movement -------------------------------------------------------->
    <TD><b>Bewegung:</B></TD>
    <TD align=middle><b>Grundgeschw:</B><BR><%= base.getAttribute("Speed").getStringValue() %></TD>
    <TD align=middle><b>Bewegung:</B><BR><%= base.getAttribute("Move").getStringValue() %></TD>
  </TR>
  <TR>
<!-------- Endurance -------------------------------------------------------->
    <TD><b>Belastung:<BR></B>Keine (0):<BR>Gering(1):<BR>Mittel (2):<BR>Stark(3):<BR>Extrem(4):</TD>
    <TD><BR>
	<%= base.getAttribute("Load0").getStringValue() %><BR>
	<%= base.getAttribute("Load1").getStringValue() %><BR>
	<%= base.getAttribute("Load2").getStringValue() %><BR>
	<%= base.getAttribute("Load3").getStringValue() %><BR>
	<%= base.getAttribute("Load4").getStringValue() %>
	</TD>
<!-------- Defense ---------------------------------------------------------->
    <TD><b>Passive Verteidigung:</B><BR>
<!--		Rstung: -<BR>
		Schild: -<BR> -->
		Gesamt: <%= base.getAttribute("PD").getStringValue() %><BR>
		<b>Schadensresistenz:</B><BR>
<!--		Rstung: -<BR> -->
		Gesamt: <%= base.getAttribute("DR").getStringValue() %></TD>
  </TR>
  <TR><TD colSpan=3><b>Aktive Verteidigung:</B></TD></TR>
  <TR>
    <td align=center>Ausweichen:<BR><%= base.getAttribute("Dodge").getStringValue() %><BR><small>=BW</SMALL></TD>
    <TD align=center>Parieren:<BR><%= base.getAttribute("Parry").getStringValue() %><BR><small>=Waffe/2</SMALL></TD>
    <TD align=center>Abblocken:<BR><%= base.getAttribute("Block").getStringValue() %><BR><small>=Schild/2</SMALL></TD>
  </TR>
  </TABLE>
</TD>
<TD>
<!-------- Advantages/Disadvantages/Quirks --------------------------------->
  <TABLE border=1>
  <TR><TH colspan=2>Vorteile, Nachteile</TH></TR>
  <TR><TH>CP</TH><TH></TH></TR>
<% 	for (Iterator it = main.getObject("AdvantageList").getSubObjects(); it.hasNext();) {
		robj = (RpdlObject)it.next();
%>
  <TR>
    <TD><%= robj.getAttribute("CPCost").getStringValue() %></TD>
    <TD><%= robj.getAttribute("Name").getStringValue() %></TD>
  </TR>
<% } %>
  </TABLE>
  <p></P>

<!-------- Skills ---------------------------------------------------------->
  <TABLE border=1>
  <TR><TD colspan=3 align=middle><b><big>Fertigkeiten:</BIG></B></TD>
  <TR><TH>CP</TH><TH></TH><TH>FW</TH></TR>
<% 	for (Iterator it = main.getObject("SkillList").getSubObjects(); it.hasNext();) {
		robj = (RpdlObject)it.next();
%>
  <TR>
    <TD align=right><%= robj.getAttribute("CPCost").getStringValue() %></TD>
    <TD align=middle title="<%= robj.getAttribute("Description").getStringValue() %>"><%= robj.getAttribute("Name").getStringValue() %></TD>
    <TD align=right><%= robj.getAttribute("Skill").getStringValue() %></TD>
  </TR>
<% } %>
  </TABLE> 
</TD></TR>
<TR><TD>

<!-------- Weapons ---------------------------------------------------------->
  <TABLE border=1>
  <TR><TH>Waffe</TH><TH>Sto</TH><TH>Schwung</TH><TH>SS</TH><TH>ZG</TH><TH>1/2s</TH><TH>Max</TH><TH>Kosten</TH><TH>Gewicht</TH></TR>
<% 	for (Iterator it = main.getObject("ItemList").getSubObjects(); it.hasNext();) {
		robj = (RpdlObject)it.next();
		if (!robj.isType("Weapon")) continue;
%>
  <TR>
  <TD title="<%= robj.getAttribute("Description").getStringValue() %>"><%= robj.getAttribute("Name").getStringValue() %></TD>
  <TD>
  <%-- Display the thrust damage --%>
  <% if (robj.isType("ThrustDamage")) { %>
	  <nobr><%= robj.getAttribute("TotalThrustDamage").getStringValue() %></nobr>
  <% } else { %>
  	  --
  <% } %>
  </TD>
  <TD>
  <%-- Display the swing damage --%>
  <% if (robj.isType("SwingDamage")) { %>
	  <nobr><%= robj.getAttribute("TotalSwingDamage").getStringValue() %></nobr>
  <% } else { %>
  	  --
  <% } %>
  </TD>
  <%-- Display the attributes for ranged weapons --%>
  <% if (robj.isType("RangedWeapon")) { %>
  <TD><%= robj.getAttribute("Snapshot").getStringValue() %></TD>
  <TD><%= robj.getAttribute("RangeAim").getStringValue() %></TD>
  <TD><%= robj.getAttribute("HalfDmg").getStringValue() %></TD>
  <TD><%= robj.getAttribute("RangeMax").getStringValue() %></TD>
  <% } else { %>
  <TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD><TD>&nbsp;</TD>
  <% } %>
  <TD>$<%= robj.getAttribute("Price").getStringValue() %></TD>
  <TD><%= robj.getAttribute("Weight").getStringValue() %>kg</TD>
  </TR>
<% } %>
  </TABLE>

<!-------- Spells ---------------------------------------------------------->
   <TABLE border=1>
  <TR><TH>Spruch</TH><TH>CP</TH><TH>FW</TH><TH>Kosten</TH><TH>Dauer</TH</TR>
<% 	for (Iterator it = main.getObject("MagicList").getSubObjects(); it.hasNext();) {
		robj = (RpdlObject)it.next();
%>
  <TR>
  <TD title="<%= robj.getAttribute("Description").getStringValue() %>"><%= robj.getAttribute("Name").getStringValue() %></TD>
  <TD><%= robj.getAttribute("CPCost").getStringValue() %></TD>
  <TD><%= robj.getAttribute("Skill").getStringValue() %></TD>
  <TD><%= robj.getAttribute("SpellCost").getStringValue() %></TD>
  <TD><%= robj.getAttribute("SpellDuration").getStringValue() %></TD>
  </TR>
<% } %>
  </TABLE>

<!-------- Items ---------------------------------------------------------->
  <TABLE border=1>
  <TR><TH>Gegenstand</TH><TH>Kosten</TH><TH>Gewicht</TH><TH>Beschreibung</TH></TR>
<% 	for (Iterator it = main.getObject("ItemList").getSubObjects(); it.hasNext();) {
		robj = (RpdlObject)it.next();
		if (robj.isType("Weapon")) continue;	// no weapons
%>
  <TR>
  <TD><%= robj.getAttribute("Name").getStringValue() %></TD>
  <TD>$<%= robj.getAttribute("Price").getStringValue() %></TD>
  <TD><%= robj.getAttribute("Weight").getStringValue() %>kg</TD>
  <TD><%= robj.getAttribute("Description").getStringValue() %></TD>
  </TR>
<% } %>
  </TABLE>
</TD>
<TD valign=bottom>
  <TABLE border=1>
  <TR><TD></TD><TD>CP</TD></TR>
  <TR><TD>Attribute:</TD><TD><%= base.getAttribute("AttributeCP").getStringValue() %></TD></TR>
  <TR><TD>Vorteile:</TD><TD><%= main.getObject("AdvantageList").getAttribute("UsedCP").getStringValue() %></TD></TR>
  <TR><TD>Fertigkeiten:</TD><TD><%= main.getObject("SkillList").getAttribute("UsedCP").getStringValue() %></TD></TR>
  <TR><TD>Magie:</TD><TD><%= main.getObject("MagicList").getAttribute("UsedCP").getStringValue() %></TD></TR>
  <TR><TD><b>Gesamt CP:</B></TD><TD><%= base.getAttribute("CharacterPoints").getStringValue() %></TD></TR>
  </TABLE>
</TD></TR>
</TABLE>
<!-------- History ---------------------------------------------------------->
<h2> Die Geschichte von <%= base.getAttribute("Name").getStringValue() %></h2>
<table border=0>
<%! RpdlHistoryEntry hist; %>
<% 	for (Iterator it = main.getHistoryEntries(); it.hasNext();) {
		hist = (RpdlHistoryEntry)it.next();
%>
<tr><td colspan=2><big><b>Datum: <%= hist.getDateFormatted() %>: <%= hist.getTitle() %></b></big></td></tr>
<tr><td width=20></td><td><%= hist.getText() %></td></tr>
<% } %>
</body></html>
<%-- end no error --%>
<% } %>

